/* カラートレーサー*/

/*
  黄   105-125
  橙　 180-200
  赤   219-240
  緑　 160-199
  白   200-220
  (青)　 200-208　
*/
#include <ColorSensor.h>
#include <RPlib.h>
#include <LedControl.h>
int swPin=10;
RPmotor mc0(MC0);//MC0に繋がっているモータを指定する
RPmotor mc1(MC1);//MC1に繋がっているモータを指定する
RPmotor mc2(MC2);//MC2に繋がっているモータを指定する
LedControl lc = LedControl(11, 13, 1); //おまじない

void setup() {
  pinMode(swPin,INPUT_PULLUP);
  lc.shutdown(0, false); //７セグLED　リセット
  lc.setIntensity(0, 4); //７セグLED　色の濃さ設定
  lc.clearDisplay(0);//７セグLED　表示をクリア
  ColorSensor.begin(100, 0); // カラーセンサの積分時間を指定 x10[ms]　 値が大きいほどセンサ値の精度が良くなるが、そのぶん時間がかかる　6000で600[ms] 最大 6144
  ColorSensor.led(3);
  ColorSensor.led(4);
  ColorSensor.led(5); 
  ColorSensor.led(6);
  ColorSensor.led(7);
  
}
       int flag = 0; 
       int iro = 0;
       int R = 0;
       int B = 0;
       int W = 0;

void loop()
{

  if(digitalRead(swPin)==HIGH)  //スイッチが入ったら
  {
    flag = 1;
  }
      while(flag == 1)
      {        if(ColorSensor.colorRead())
         {
          word clear = ColorSensor.colorClear();//色センサの数値初期化
          
            word red = ColorSensor.colorRed();//色センサの赤要素検出
            word green = ColorSensor.colorGreen();//色センサの緑要素検出
            word blue = ColorSensor.colorBlue();//色センサの青要素検出
      
            ColorSensor.convertHSV(red, green, blue);//RGBデータをHSVデータに変更する
            word h = ColorSensor.convertH();
            word s = ColorSensor.convertS();
            word v = ColorSensor.convertV();
       
            ColorSensor.convertRGB(h);//HSVをRGBに変更
            byte ledR = ColorSensor.convertRed();
            byte ledG = ColorSensor.convertGreen();
            byte ledB = ColorSensor.convertBlue();
      
            lc.setDec(0, h); //H値を７セグLEDで表示する {白を読み取れるか試しにsの値表示にしてみました}
      
      
           
            //if(sw1=)
         
           if(h>=195&&h<=209)//白
             {
             mc0.rotate(20);
             mc1.rotate(-230);
             mc2.rotate(200);
             
              }
         else if(h>=210&&h<=220)//青
           
           {
             mc0.rotate(250);
             mc1.rotate(-90);
             mc2.rotate(250);
           } 
           else  if(h>=10&&h<=40)//オレンジ
           {
             mc0.rotate(-240);
             mc1.rotate(-200);
             mc2.rotate(-150);
           }
        else if(h>=240&&h<=285)//赤
           {
               mc0.rotate(0);
               mc1.rotate(-250);
               mc2.rotate(250);
           }  
         else if(h>=140&&h<=190)    //緑
          {
             mc0.rotate(-150);
             mc1.rotate(-100);
             mc2.rotate(100);
           }
           
           else if(h>=73&&h<=87)//黄色
           {
               mc0.rotate(0);
               mc1.rotate(0);
               mc2.rotate(0);
           }  
        }
      }
 delay(1);
}
